      program combinatorial

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c------------------------------------------------
c This program accompanies the book:
c             C. Pozrikidis
c "Numerical Computation in Science and Engineering"
c        Oxford University Press
c------------------------------------------------

c---------------------------------------------
c Computation of the combinatorial in two ways
c---------------------------------------------

 98   Continue

      write (6,*)
      write (6,*) " Will compute the (n/m) combinatorial"
      write (6,*)

 97   Continue

      write (6,*) " Please enter n and m (n>=m)"
      write (6,*)
      write (6,*) " 0 for either one to quit"
      write (6,*) "-------------------------"
      read (5,*) n,m

      If(n.eq.0) Go to 99
      If(m.eq.0) Go to 99

c---
c trap
c---

      If(m.gt.n) then
       write (6,*)
       write (6,*) "Invalid input; please try again"
       write (6,*)
       Go to 97
      End If

c-------------
c direct method
c--------------

      nf = 1      ! compute n!

      Do i=1,n
       nf = nf*i
      End Do

      mf = 1      ! compute m!

      Do i=1,m
       mf = mf*i
      End Do

      nmmf = 1    ! compute (n-m)!

      Do i=1,n-m
       nmmf = nmmf*i
      End Do

      nmc = nf/(mf*nmmf)

      write (6,*) 
      write (6,*) " Combinatorial by the direct method:"
      write (6,*) 
      write (6,*) nmc
      write (6,*) 

c----------------------------------------------
c  better method according to algorithm (1.4.7)
c----------------------------------------------

c---
c find the minimum of m and n-m
c---

      l = m
      if((n-m).lt.l) l = n-m

c---
c some magic
c---

      nmc = 1
      Do k=1,l
       nmc = nmc*(n-k+1)/k
      End Do

      write (6,*) 
      write (6,*) " Combinatorial by the improved method:"
      write (6,*) 
      write (6,*) nmc
      write (6,*) 

      Go to 98

c-----
c Done
c-----

  99  Continue

      Stop
      End
