clear all

%===============
% demonstrate the generarized Sherman-Morrison formula
%==============

B = [1 2 3;
     2 3 4;
     1 4 5];

c1 = 1.4;
u1 = [3.1 4.2 9.3]';
v1 = [2.4 3.5 7.6]';

c2 = 3.4;
u2 = [1.1 2.2 3.4]';
v2 = [6.7 5.8 4.9]';

c3 =-0.4;
u3 = [3.1 9.2 9.4]';
v3 = [3.7 3.8 3.9]';

c4 =-3.4;
u4 = [1.1 1.2 1.4]';
v4 = [1.7 1.8 1.9]';

Xi = zeros(4,4);

Xi(1,1) = c1;
Xi(2,2) = c2;
Xi(3,3) = c3;
Xi(4,4) = c4;

U(:,1) = u1;
U(:,2) = u2;
U(:,3) = u3;
U(:,4) = u4;

V(:,1) = v1;
V(:,2) = v2;
V(:,3) = v3;
V(:,4) = v4;

c1*u1*v1' + c2*u2*v2' + c3*u3*v3' + c4*u4*v4'
U*Xi*V'

%----

w1 = u1'/B';
w2 = u2'/B';
w3 = u3'/B';
w4 = u3'/B';

G(1,1) = v1'*w1';
G(1,2) = v1'*w2';
G(1,3) = v1'*w3';
G(1,4) = v1'*w4';

G(2,1) = v2'*w1';
G(2,2) = v2'*w2';
G(2,3) = v2'*w3';
G(2,4) = v2'*w4';

G(3,1) = v3'*w1';
G(3,2) = v3'*w2';
G(3,3) = v3'*w3';
G(3,4) = v3'*w4';

G(4,1) = v4'*w1';
G(4,2) = v4'*w2';
G(4,3) = v4'*w3';
G(4,4) = v4'*w4';

A = B + c1*u1*v1' + c2*u2*v2' + c3*u3*v3' + c4*u4*v4';

invA = inv(A)
invB = inv(B);
invA1 = invB-invB*U*inv(inv(Xi)+G)*V'*invB

G
G = V'*invB*U
