      subroutine sm_3d_tr
     +
     +  (npts
     +  ,f
     +  ,j_trunc
     +  ,f_sm
     +  )

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c----------------------------------------
c Smoothing of the function f defined over
c a triangulated closed surface.
c
c SYMBOLS
c -------
c
c f(i):    
c          function to be smoothed
c          evaluated at the ith node
c
c rmpp(i,j,m):  
c
c           Lower triangular matrix
c           with dimensions (j_max+1)x(j_max+1)
c           holding the modified Legendre functions
c           Generated by subroutine: sm_3d_cl_tr_aux
c
c afl, bfl:  Fourier-Legendre coefficients
c
c----------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension    f(1026),f_sm(1026)
      Dimension  phi(1026)
      Dimension rmpp(1026,0:32,0:32)

      Dimension afl(0:32,0:32),bfl(0:32,0:32)

c--------------
c common blocks
c--------------

      common/fleg/phi,rmpp
      common/flegc/afl,bfl

c-------------------------
c Reconstruct the function
c-------------------------

      Do i=1,npts

        f_sm(i) = 0.5D0*afl(0,0)*rmpp(i,0,0)

        Do j=1,j_trunc
         f_sm(i) = f_sm(i) + 0.5D0*afl(j,0)*rmpp(i,j,0)
         Do m=1,j
          arg = m*phi(i)
          f_sm(i) = f_sm(i) + rmpp(i,j,m)*(afl(j,m)*cos(arg)
     +                                    +bfl(j,m)*sin(arg))
         End Do
        End Do

c       write (6,100) i,f(i),f_sm(i)

      End Do

c-----
c Done
c-----

 100  Format (1x,i4,10(1x,f10.5))

      Return
      End
