close all
clear all

%==================
% compute the meniscus around a floating sphere
%==================

%----
% parameters
%----

a = 1.0;   % particle radius

rho1 = 0.0;
rho2 = 1.0;

kappa = 0.9;
kappa =-0.5;
kappa = 0.0;
kappa = 0.5;

smax = 2.0;

ndiv = 64;
ndiv = 128;

%=========
% plot beta vs alpha
% plot xc vs alpha
%=========

figure(1)
hold on
set(gca,'fontsize',14)
xlabel('\alpha/\pi','fontsize',14)
ylabel('\beta/\pi','fontsize',14)
axis([0 1 0 1])
box on

figure(2)
hold on
set(gca,'fontsize',14)
xlabel('\alpha/\pi','fontsize',14)
ylabel('x_c/a','fontsize',14)
axis([0 1 -1 1])
box on

%============
 for iloop=1:4 % over capillary length
%for iloop=2:2 % over capillary length
%============

if(iloop==1)
 capl = 0.5   % capilary length
 smax = 1.5;
 mincut = 0.01;
 maxcut = 0.99;
elseif(iloop==2)
 capl = 1.0   % capilary length
 smax = 3.5;
 mincut = 0.01;
 maxcut = 0.99;
elseif(iloop==3)
 capl = 2.0   % capilary length
 smax = 4.5;
 mincut = 0.01;
 maxcut = 0.99;
elseif(iloop==4)
 capl = 4.0   % capilary length
 smax = 6.0;
 mincut = 0.02;
 maxcut = 0.98;
end

alpha = pi/8;
alpha = 0.00;   % to unlock
alpha = 999;    % to unlock
alpha = 0.98*pi;
alpha = 0.0242*pi;

alphain = alpha;

%---
% compute the meniscus
%---

iplot_shape=1;

[s,x,q,beta,alpha,xc,xcl,scl ...
       ,beta_flat,xc_flat ...
        ,al_scan,bt_scan,xc_scan ...
                ,bx_scan,xx_scan ...
                ,bk_scan,xk_scan] ...
 ...
 = flsphere(a,capl,rho1,rho2 ...
           ,kappa,alphain,smax,ndiv ...
           ,mincut,maxcut ...
           ,iplot_shape);

%-----------
% plot
%-----------

  figure(1)
  if(iloop==1)
   plot(al_scan,bt_scan,'k','LineWidth',3)
  else
   plot(al_scan,bt_scan,'k')
  end
% plot(al_scan,bx_scan,'r--')
% plot(al_scan,bk_scan,'k:')

  figure(2)
  if(iloop==1)
   plot(al_scan,xc_scan,'k','LineWidth',3)
  else
   plot(al_scan,xc_scan,'k','LineWidth',1)
  end
%  plot(al_scan,xx_scan,'r--')
%  plot(al_scan,xk_scan,'k:')

%~~~
end
%~~~

figure(1)
plot([0,1],[beta_flat/pi,beta_flat/pi],'k')

figure(2)
plot([0,1],[xc_flat,xc_flat],'k')
