function [x,s] = men_ax_ode ...
 ...
      (npts ...
      ,capls ...
      ,a ...
      ,dthet ...
      ,h)

%=========================================
% FDLIB
%
% Copyright by C. Pozrikidis, 1999
% All rights reserved.
%
% This program is to be used only under the
% stipulations of the lisencing agreement
%=========================================

%--------------------------------------------
% integrate ODEs by the modified Euler method
%--------------------------------------------

%--------
% prepare
%--------

 dtheth = 0.5D0*dthet;

%-----------
% centerline
%-----------

 thet = 0.0D0;
 s(1) = 0.0D0;
 x(1) = 0.0D0;

%---
  for i=1:npts
%---

    if(i==1) 
      xp = 0.0D0;
      sp = 2.0D0*capls/h;
    else
      cs = cos(thet);
      sn = sin(thet);
       Q  = (x(i)+h)/capls-sn/s(i);
       xp = sn/Q;
       sp = cs/Q;
    end

     xsv  = x(i);  % save
     ssv  = s(i);  % save
     xpsv = xp;
     spsv = sp;

     i1 = i+1;

     thet  = thet+dthet;
     x(i1) = x(i)+xp*dthet;
     s(i1) = s(i)+sp*dthet;

     cs = cos(thet);
     sn = sin(thet);
     Q  = (x(i1)+h)/capls-sn/s(i1);
     xp = sn/Q;
     sp = cs/Q;

     x(i1) = xsv + (xpsv+xp)*dtheth;
     s(i1) = ssv + (spsv+sp)*dtheth;

%---
   end
%---

%-----
% done
%-----

return
