      subroutine chan_2d 
     +
     +  (a
     +  ,visc
     +  ,den
     +  ,gac
     +  ,V1,V2
     +  ,chi
     +  ,beta
     +  ,y
     +  ,flow_rate
     +  ,umean
     +  ,u
     +  )

c=========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement
c=========================================

c=========================================
c Flow in a 2D channel confined between
c two parallel plane walls located at y= (+-) a
c=========================================

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi = 3.14159 265358D0
 
c--------
c prepare
c--------

      pg_mod = chi + den*gac*sin(beta)     ! modified pressure gradient

c-------
c launch
c-------

      u = V1+(y+a)/(2.0*a) *(V2-V1)     ! shear-driven
     +  + 0.5*pg_mod*(a**2-y**2)/visc   ! pressure and grav-driven

c----------------------------
c flow rate and mean velocity
c----------------------------

      flow_rate = (V1+V2)*a 
     +          + 2.0*pg_mod*a**3/(3.0D0*visc)

      umean = flow_rate/(2.0*a)

c-----
c done
c-----

      Return
      End
