function u = chan_2d_imp ...
   ...
   (h ...
   ,visc ...
   ,den ...
   ,V ...
   ,Max ...
   ,time ...
   ,y ...
   )

%=======================================================
% Flow in a channel confined between two parallel walls
% due to the impulsive translation of the lower wall
% parallel to itself at constant velocity.
%
% The walls are located at y = 0, h
%=======================================================

%--------
% prepare
%--------

  hs  = h*h;
  rnu = visc/den;  % kinematic viscosity

%---------------------
% compute the velocity
%---------------------

  u = 0.0;

  for j=1:Max
   u = u + sin(j*pi*y/h)*exp(-j^2*pi^2*rnu*time/hs)/j;
  end

  u = V*(1.0-y/h-2.0*u/pi);

%-----
% done
%-----

 return
