      program chan_2d_osc_dr 

c==========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c==========================================

c==========================================
c Flow in a channel due to an oscillating wall
c The walls are located at y = 0, h
c The lower wall is oscillating with amplitude: Vamp
c
c V_wall = Vamp * cos(omega*time)
c==========================================

      Implicit Double Precision (a-h,o-z)

c---
c constants
c---

      pi = 3.14159 265358 D0

      Null = 0
      None = 1
      Ntwo = 2
      zero = 0.0

c-----
c input
c-----

      open (1,file='chan_2d_osc.dat')
        read (1,*) nprof
        read (1,*) visc
        read (1,*) den
        read (1,*) omega
        read (1,*) Vamp
        read (1,*) h        ! channel width
      close (1)

c---------------
c prepare to run
c---------------

      open (2,file='chan_2d_osc.out')

c---------------------------------
c print data to plot channel walls
c---------------------------------

      write (2,900) Ntwo
      write (2,900) None,-h,zero
      write (2,900) Ntwo, h,zero
      write (2,900) Ntwo
      write (2,900) None,-h,h
      write (2,900) Ntwo, h,h

c-----
c menu
c-----

 93   Continue

      write (6,*)
      write (6,*)  " Enter 0 to quit"
      write (6,*)  "       1 for one profile"
      write (6,*)  "------------------------"
      read  (5,*) menu

      If(menu.eq.0) Go to 99

c------------
c One profile
c------------

      If(menu.eq.1) then

      nprof1 = nprof+1
      step   = h/(nprof1-1.0)

 94   Continue

      write (6,*)
      write (6,*) " Please enter omega*t in multiples of pi"
      write (6,*) " omega is the angular frequency"
      write (6,*) " Enter 99 to quit"
      write (6,*) " ----------------"
      read (5,*) ot

      If(ot.eq.99) Go to 99

c---
c generate a profile
c---

      write (6,*)
      write (6,*) "u, y"
      write (6,*)

      write (2,900) nprof1

      y = 0.0

      Do i=1,nprof1

        call chan_2d_osc
     +
     +  (h
     +  ,visc
     +  ,den
     +  ,Vamp
     +  ,omega
     +  ,ot
     +  ,y
     +  ,u
     +  )

        write (2,900) i,u,y
        write (6,900) i,u,y

        y = y +step

      End Do

c---
c done with the profile
c---

      Go to 94

      End If

c-----
c done
c-----

  99  Continue

      write (2,900) null
      close (2)

 900  Format (1x,i3,4(1x,f10.5))

      Stop
      End
