%---
clear all
close all
hold on
%---

%===================================================
% Flow in a 2D channel due to an oscillatory
% pressure gradient:
%
% pg = - pgamp * sin(Omega*time)
%
% The channel walls are located at y = 0, h
%===================================================

nprof = 32;    % number of points for a profile
h = 1;        % channel width 
visc = 1.0;    % viscosity
den = 1.0;     % density
pgamp = 1.0;      % pressure gradient

Omega = 2.0;   % angular frequency
Omega = 36.0;   % angular frequency
Omega = 4.0;   % angular frequency

step=h/nprof;

%---
 for iloop=1:8
%---

     if(iloop==1) ot=0.00*pi;
 elseif(iloop==2) ot=0.25*pi;
 elseif(iloop==3) ot=0.50*pi;
 elseif(iloop==4) ot=0.75*pi;
 elseif(iloop==5) ot=1.00*pi;
 elseif(iloop==6) ot=1.25*pi;
 elseif(iloop==7) ot=1.50*pi;
 elseif(iloop==8) ot=1.75*pi;
 end

 y=0;

 for i=1:nprof+1

  u = chan_2d_wom  ...
 ...
     (h ...
     ,visc ...
     ,den ...
     ,pgamp ...
     ,Omega ...
     ,ot ...
     ,y ...
     );

  Uhagenc =  pgamp*h^2/(8.0*visc);

  xplot(i) = u/Uhagenc;
  yplot(i) = y/h;

  y = y+step;

 end

 if(iloop==1)
  plot(xplot,yplot,'k--')
 elseif(iloop==2)
  plot(xplot,yplot,'k-.')
 elseif(iloop==3)
  plot(xplot,yplot,'k:')
 else
  plot(xplot,yplot,'k')
 end


%---
 end
%---

 xmin=-1; xmax=1.0;
 ymin= -0.2; ymax=1.2;
 axis([xmin xmax ymin ymax])
 plot([0 0],[0 h],'c');
 plot([xmin xmax],[0 0],'r','linewidth',4);
 plot([xmin xmax],[h h],'r','linewidth',4);
 xlabel('u_x/U','fontsize',15)
 ylabel('y/h','fontsize',15)
 set(gca,'fontsize',15)
 box

