function u = plate_osc1 ...
 ...
   (visc ...
   ,den ...
   ,zeta ...
   ,omega ...
   ,ot ...
   ,y ...
   )

%------------------------------
% Rayleigh's first problem:
%
% Unidirectional flow in a semi-infinite fluid
% due to an oscillating plate 
%------------------------------

%--------
% prepare
%--------

 rnu   = visc/den;             % kinematic viscosity
 delta = sqrt(2.0*rnu/omega);  % boundary-layer thickness

%---------------------
% compute the velocity
%---------------------

 yr = y/delta;
 u  = zeta/(den*omega)*(exp(-yr)*cos(ot-yr)-cos(ot));

%---
% done
%---

return
