      subroutine joukowski (xc,yc,Vx,Vy,circ,x,y,f)

c------------------------------
c Stream function for flow past 
c the Joukowski airfoil
c in the parametric plane
c------------------------------

      Implicit double precision (a-h,o-z)

      rads = (xc+1.0)**2+yc**2
      rad  = sqrt(rads)

      xh = x-xc
      yh = y-yc

      r = sqrt(xh*xh+yh*yh)
      q = acos(xh/r)
      if(yh.le.0) q = -q

      f = -2.0*circ*log(r)
     +    -(r-rads/r)*(Vx*sin(q)+Vy*cos(q))

c---
c done
c---

      return
      end
