      subroutine ps_ring (x,s,x0,s0,u,v)

c----------------------
c Potential flow
c
c Ring of point sources
c----------------------

      Implicit Double Precision (a-h,o-z)

      Dx   = x-x0
      Dxs  = Dx*Dx
      ss0s = (s+s0)**2
      rks  = 4.0*s*s0/(Dxs+ss0s)

      call ell_int (rks,F,E)

      tmp1 = sqrt(Dxs+ss0s)
      rksc = 1.0-rks
      RJ30 = E/rksc
      RJ31 = (-2.0*F+(2.0-rks)*E/rksc)/rks
      cf   = 4.0/tmp1**3
      RI30 = cf*RJ30
      RI31 = cf*RJ31

      u = - dx * RI30
      v = - s*RI30+s0*RI31

c---
c done
c---

      return
      end
