      subroutine sphrd_pr_axial (x,y,c,delx,f)

c---
c Axial potential flow past a prolate spheroid
c Evaluation of the velocity potential
c from a singularity representation
c---

      Implicit double precision (a-h,o-z)

      N   = 64
      dx0 = 2.0*c/N
      f   = 0.0

      Do i=1,N
        x0 = -c+(i-0.50)*dx0
        dx = x-x0
        r2 = dx*dx+y*y
        r  = sqrt(r2)
        r3 = r2*r
        d  = c*c-x0*x0
        f = f + dx*d/r3
      End Do

      f = - 0.5*f*dx0/delx

      f = -f+x

c---
c Done
c---

      Return
      End
