      subroutine stokes_drop (x,y,a,vsr,u,v)

c---
c Stokes flow due to a moving viscous drop
c---

      Implicit double precision (a-h,o-z)

      as = a*a
      xs = x*x
      ys = y*y
      xy = x*y
      rs = xs+ys
      r  = sqrt(rs)
      rc = rs*r
      q  = acos(x/r)

      in = 1
      if(r.gt.a) in = 0

      if(in.eq.0) then      ! outside the drop
       c0 = 0.25/(vsr+1.0)
       c1 = 3.0*vsr+2.0+    vsr*as/rs
       c2 = 3.0*vsr+2.0-3.0*vsr*as/rs
       u = c0*(c1*a/r + c2*a*xs/rc)
       v = c0*          c2*a*xy/rc
      else                  ! inside the drop
       c0 = 0.5/(vsr+1.0)
       c1 = 2.0*vsr+3.0-2.0*rs/as
       u  = c0*(c1+xs/as)
       v  = c0*    xy/as
      end if

c---
c done
c---

      return
      end
