      subroutine tube_crc_sec
     +
     +  (a
     +  ,alpha
     +  ,s
     +  ,phi
     +  ,V
     +  ,u
     +  )

c===========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c===========================================

c===========================================
c Steady flow through a circular tube
c due to the translation the sector:
c
c -alpha<phi<alpha
c
c SYMBOLS:
c --------
c
c alpha:  semi-angle of the translating sector
c===========================================

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi = 3.14159 265358D0

c-------------------
c velocity at s, phi
c-------------------

c---
      if(abs(s-a).gt.0.0000001) then      ! off the wall
c---

        tmp = (a+s)/(a-s)

        u   = V/pi * ( atan(tmp*tan(0.5*(alpha-phi)))
     +                +atan(tmp*tan(0.5*(alpha+phi)))
     +                )
c---
      else      ! on the wall
c---

        if(abs(phi).lt.abs(alpha)) then
         u = V
        else
         u = 0.0D0
        end if

c---
      end if
c---
  
c-----
c Done
c-----

      Return
      End
