      program tube_crc_trans_dr

c=========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement
c=========================================

c=========================================
c Transient flow in a circular tube
c due to the sudden application of a 
c constant pressure gradient
c=========================================

      Implicit Double Precision (a-h,o-z)

c---
c constants
c---

      pi = 3.14159 265358 D0

      Null = 0
      None = 1
      Ntwo = 2
      zero = 0.0

c---
c input
c---

      open (1,file="tube_crc_trans.dat",status="unknown")

        read (1,*) nprof   ! number of points for a profile
        read (1,*) visc    ! viscosity
        read (1,*) den     ! density
        read (1,*) a       ! tube radius
        read (1,*) pg      ! negative of pressure gradient

      close (1)

c---------------
c prepare to run
c---------------

      open (2,file="tube_crc_trans.out",status="unknown")

      nprof1 = nprof+1
      step   = a/(nprof1-1.0)

c----------------------------------
c print data for plotting tube wall
c----------------------------------

      write (2,900) Ntwo
      write (2,900) None,-a,a
      write (2,900) Ntwo, a,a

c---
c menu
c---

      write (6,*)
      write (6,*)  " Enter 0 to quit"
      write (6,*)  "       1 for one profile"
      write (6,*)  "------------------------"
      read  (5,*) menu

      if(menu.eq.0) Go to 99

c------------
c One profile
c------------

      if(menu.eq.1) then

 94   Continue

      write (6,*) 
      write (6,*) " Please enter time"
      write (6,*) "        99 to quit"
      write (6,*) " -----------------"
      read (5,*) time

      if(time.eq.99) Go to 99

      write (6,*)
      write (6,*) " u, sigma"
      write (6,*)

      write (2,900) nprof1,time

      sigma = 0.0        ! radial position

      Do i=1,nprof1

       call tube_crc_trans
     +
     +    (a
     +    ,visc
     +    ,den
     +    ,pg
     +    ,time
     +    ,sigma
     +    ,u
     +    )

       write (2,900) i,u,sigma
       write (6,900) i,u,sigma

       sigma = sigma + step

      End Do

c---
c Done with a profile
c---

      Go to 94

      End If

c-----
c Done
c-----

  99  Continue

      write (2,900) Null
      close (2)

 900  Format (1x,i3,4(1x,f10.5))

      Stop
      End
