      subroutine elv_max_min
     +
     + (NSG
     + ,x,y
     + ,Xmax,Ymax
     + ,Xmin,Ymin
     + )

c==========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c==========================================

c==========================================
c Maximum and minimum elevation of interface
c by local parabolic interpolation
c==========================================

      Implicit Double Precision (a-h,o-z)

      Dimension X(-10:500),Y(-10:500)

c------------------
c maximum elevation
c------------------

      f = -100.0D0
      M = 0
      Do j=1,NSG
        if(Y(j).gt.f) then
           F = Y(j)
           M = j
        end if
      End Do

      Ma = M-1
      M1 = M
      M2 = M+1

      xx0 = X(Ma)
      xx1 = X(M1)
      xx2 = X(M2)

      yy0 = Y(Ma)
      yy1 = F
      yy2 = Y(M2)

      tm2 = (yy2-yy1)/(xx2-xx1)
      tm1 = (yy0-yy1)/(xx0-xx1)
      bbb = (tm2-tm1)/(xx2-xx0)
      ccc =  tm2-bbb*(xx2-xx1)

      Xmax = -0.50*ccc   /bbb + xx1
      Ymax = -0.25*ccc**2/bbb + yy1

c------------------
c minimum elevation
c------------------

      F = 100.0
      M = 0
      Do J=1,NSG
        if(Y(J).lt.F) then
           F = Y(J)
           M = J
        end if
      End Do

      Ma = M-1
      M1 = M
      M2 = M+1

      xx0 = X(Ma)
      xx1 = X(M1)
      xx2 = X(M2)

      yy0 = Y(Ma)
      yy1 = F
      yy2 = Y(M2)

      tm2 = (yy2-yy1)/(xx2-xx1)
      tm1 = (yy0-yy1)/(xx0-xx1)
      bbb = (tm2-tm1)/(xx2-xx0)
      ccc = tm2-bbb*(xx2-xx1)

      Xmin = -0.50*ccc   /bbb + xx1
      Ymin = -0.25*ccc**2/bbb + yy1

c-----
c Done
c-----

      Return
      End
