      subroutine grid_2d
     +
     +   (ax,bx
     +   ,ay,by
     +   ,Nx,Ny
     +   )

c======================================
c  Generate a uniform Cartesian grid 
c  over a rectangular area
c
c  SYMBOLS:
c  --------
c
c  Nx :  number of x intervals
c  Ny :  number of y intervals
c
c  Dx :  length of x interval
c  Dy :  length of y interval
c
c  glx(i) :  x-position of vertical ith grid line
c  gly(i) :  y-position of horizontal ith grid line
c
c  [gpx(i,j), gpy(i,j)] : coordinates of (i,j) grid point
c======================================

      Implicit Double Precision (a-h,o-z)

      Dimension glx(129), gly(129)
      Dimension gp_x(129,129),gp_y(129,129)

c-------------
c common blocks
c-------------

      common/grid_2d_1/glx,gly
      common/grid_2d_2/gp_x,gp_y

c--------
c prepare
c--------

      Dx = (bx-ax)/Nx
      Dy = (by-ay)/Ny

      Nx1 = Nx+1
      Ny1 = Ny+1

c------------------------
c generate the grid lines
c------------------------

      Do i=1,Nx1
       glx(i) = ax+(i-1.0D0)*Dx
      End Do

      Do i=1,Ny1
       gly(i) = ay+(i-1.0D0)*Dy
      End Do

c-------------------------
c generate the grid points
c-------------------------

      Do i=1,Nx1
       Do j=1,Ny1

        gp_x(i,j) = glx(i)
        gp_y(i,j) = gly(j)

       End Do
      End Do

c-----
c Done
c-----

      Return
      End
