      program thread0_dr 

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c-------------------------------------------
c Capillary instability of an infinite thread 
c suspended in a viscous fluid,
c under conditions of Stokes flow
c-------------------------------------------

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi  = 3.14159 265358 D0
      pi2 = 2.0D0*pi
      pi3 = 3.0D0*pi
      pi4 = 4.0D0*pi
      pi6 = 6.0D0*pi

      null = 0

c---
c main menu
c---

      write (6,*) 
      write (6,*) " Enter:"
      write (6,*) 
      write (6,*) " 1 for a single evaluation"
      write (6,*) " 2 for a growth-rate - ka stability graph"
      write (6,*) " 0 to quit"
      write (6,*) " ---------"
      read  (5,*) menu

      If(menu.eq.0) Go to 99

      open (2,file="thread0.out",status="unknown")

      Irepeat = -1     ! repetition flag

c----------
c launching
c----------

  98  Continue

      Irepeat = Irepeat + 1

c---
c preferences
c---

      write (6,*) 
      write (6,*) " Please enter the viscosity of the thread"
      write (6,*) " 99 to quit"
      write (6,*) " ----------"
c     read  (5,*) vst
      vst = 1.0D0

      If(vst.eq.99) Go to 99

      write (6,*) 
      write (6,*) " Please enter the viscosity"
      write (6,*) " of the surrounding fluid"
      write (6,*) " 99 to quit"
      write (6,*) " ----------"
      read  (5,*) vss

      If(vss.eq.99) Go to 99

      write (6,*)
      write (6,*) " Please enter the surface tension"
      write (6,*) " 99 to quit"
      write (6,*) " ----------"
c     read  (5,*) srtn
      srtn = 1.0D0

      If(srtn.eq.99) Go to 99

      write (6,*)
      write (6,*) " Please enter the thread radius"
      write (6,*) " 0 to quit"
      write (6,*) " ---------"
c     read  (5,*) a
      a = 1.0D0

      if(a.lt.0.0000001) Go to 99

c-----------------------
      if(menu.eq.1) then
c-----------------------

      write (6,*) " Please enter the wave length L"
      write (6,*) " 998 for 2*pi"
      write (6,*) " 999 for 3*pi"
      write (6,*) " 996 for 4*pi"
      write (6,*) " 997 for 6*pi"
      write (6,*) "   99 to quit"
      write (6,*) "-------------"
      read  (5,*) RL

      If(RL.eq.99) Go to 99

      If(abs(RL-998.0).lt.0.00001) RL = pi2
      If(abs(RL-999.0).lt.0.00001) RL = pi3
      If(abs(RL-996.0).lt.0.00001) RL = pi4
      If(abs(RL-997.0).lt.0.00001) RL = pi6
      
      call thread0
     +
     +  (a,RL
     +  ,vst,vss
     +  ,srtn
     +  ,gr
     +  )

      write (6,*)
      write (6,101) gr
      write (6,*)

c---------
      Else
c---------

c---
      If(Irepeat.eq.0) then

       write (6,*) 
       write (6,*) " Will generate growth rate vs. ka curves"
       write (6,*) " Please enter number of points"
       write (6,*) " 0 to quit"
       write (6,*) " ---------"
c      read  (5,*) mplot
       mplot = 128

       If(mplot.eq.0) Go to 99
       mplot1 = mplot+1
       step = 1.0/(mplot1-1.0)

      End If
c---

      write (2,102) mplot1,vss

      Do i=1,mplot1

       wnh = (i-1.0)*step        !  ka
       If(wnh.lt.0.00000001) wnh = 0.000001  ! prevent garbage
       RL = pi2*a/wnh      ! period          

       call thread0
     +
     +   (a,RL
     +   ,vst,vss
     +   ,srtn
     +   ,gr
     +   )

c      write (6,100) i,wnh,gr
       write (2,100) i,wnh,gr

      End Do

c-----------
      End If
c-----------

      Go to 98

c-----
c Done
c-----

  99  Continue

      write (2,*) null,null
      close (2)

  100 Format (1x,i3,1x,f10.8,1x,f12.7)
  101 Format (" Growth rate =",f15.10)
  102 Format (1x,i3,1x,f10.6)

      Stop
      End
