      program thread1_dr

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c-------------------------------------------
c Capillary nstability of an infinite thread
c consisting of an inviscid fluid
c suspended in vacuum
c-------------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c constants
c---

      pi = 3.14159 265358 D0
      pi2 = 2.0D0*pi

c-----------
c parameters
c-----------

      write (6,*)
      write (6,*) " Please enter the surface tension"
      write (6,*) " 0 to quit"
      write (6,*) " ---------"
      read  (5,*) gamma

      If(gamma.eq.0) Go to 99

      write (6,*)
      write (6,*) " Please enter the density"
      write (6,*) " 0 to quit"
      write (6,*) " ---------"
      read  (5,*) rho

      If(rho.eq.0) Go to 99

      write (6,*)
      write (6,*) " Please enter the thread radius"
      write (6,*) " 0 to quit"
      write (6,*) " ---------"
      read  (5,*) a

      If(a.lt.0.0000001) Go to 99

      write (6,*)
      write (6,*) " Enter the azimuthal wave number"
      write (6,*) " 0 or 1 "
      write (6,*) " 0 corresponds to an axisymmetric wave"
      write (6,*) " -------------------------------------"
      read  (5,*) m

  98  Continue

      write (6,*)
      write (6,*) " Please enter the wave length L"
      write (6,*) " 999 for 2*pi"
      write (6,*) " 0 to quit"
      write (6,*) " ---------"
      read  (5,*) RL

      If(RL.eq.0) Go to 99

      If(abs(RL-999.0).lt.0.00001) RL = pi2
      
c---
c compute the growth rate
c----

      call thread1
     +
     +  (a,RL
     +  ,gamma,rho
     +  ,m
     +  ,cr,ci,sr,si
     +  )

      write (6,*) 
      write (6,101) cr
      write (6,102) ci
      write (6,103) sr
      write (6,104) si

      Go to 98

c------
c  Done
c------

  99  Continue

  101 Format (" Phase velocity     =",f15.10)
  102 Format (" ci                 =",f15.10)
  103 Format (" real part of sigma =",f15.10)
  104 Format (" Growth rate        =",f15.10)

      Stop
      End
