      program lvr_fs_dr

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement.
c----------------------------------------

c----------------------------------------
c Driver for velocity and stream function
c due to a line vortex ring
c in free space
c
c psi:   stream function
c u,v:   velocity components
c---------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c prepare
c---

      Iopt = 2     ! will compute velocity and stream function

c---
c input
c---
      write (6,*)
      write (6,*) "Please enter the coordinates of the lvr"
      write (6,*) "---------------------------------------"
      read  (5,*) x0,s0

  96  Continue

      write (6,*)
      write (6,*) "Please enter the coordinates of the"
      write (6,*) "velocity point"
      write (6,*)
      write (6,*) "99 for either one to quit"
      write (6,*) "-------------------------"
      read  (5,*) x,s

      If(abs(x-99.0).lt.0.000001) Go to 99
      If(abs(s-99.0).lt.0.000001) Go to 99

      call lvr_fs
     +            (Iopt
     +            ,x,s
     +            ,x0,s0
     +            ,u,v
     +            ,psi
     +            )
   
      write (6,100) u,v,psi

      Go to 96   ! repeat

  99  Continue

c---
c Done
c---

 100  Format (" Velocity:      ",2(1x,f9.6)
     +     ,/," stream function:",f9.6)

      Stop
      End
