      subroutine lvr_w 
     +
     +   (Iopt
     +   ,x,s
     +   ,x0,s0
     +   ,wall
     +   ,u,v
     +   ,psi
     +   )

c==========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement
c==========================================

c--------------------------------------------------
c Velocity components and Stokes stream function
c due to a line vortex ring
c in the presence of a wall located at x = wall
c
c If Iopt.eq.1 the subroutine computed the velocity
c If Iopt.ne.1 the subroutine computed the velocity
c              and the Stokes stream function
c--------------------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c primary ring
c---

      call lvr_fs 
     +
     +   (Iopt
     +   ,x,s
     +   ,x0,s0
     +   ,u,v
     +   ,psi
     +   )

c---
c image with respect to the wall
c---

      x0i = 2.0*wall-x0
      s0i = s0

      call lvr_fs 
     +
     +   (Iopt
     +   ,x,s
     +   ,x0i,s0i
     +   ,ui,vi
     +   ,psii
     +   )
c---
c add them up
c---

      psi = psi - psii

      u = u - ui
      v = v - vi

c---
c done
c---

      return
      end
