      program pv_w_dr

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement.
c----------------------------------------

c----------------------------------------
c Driver for flow due to a point vortex
c in a semi-infinite domain bounded by a
c plane wall
c---------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c input
c---
      write (6,*)
      write (6,*) "The wall is located at y = wall"
      write (6,*)
      write (6,*) "Please enter wall"
      write (6,*) "--------------------------------------"
      read  (5,*) wall

      write (6,*)
      write (6,*) "Please enter the coordinates of the pv"
      write (6,*) "--------------------------------------"
      read  (5,*) x0, y0

  96  Continue

      write (6,*)
      write (6,*) "Please enter the coordinates of the"
      write (6,*) "velocity point"
      write (6,*)
      write (6,*) "Enter 99 for either one to quit"
      write (6,*) "-----------------------------------"
      read  (5,*) x, y

      If(abs(x-99.0).lt.0.000001) Go to 99
      If(abs(y-99.0).lt.0.000001) Go to 99

      call pv_w
     +          (x,y
     +          ,x0,y0
     +          ,wall
     +          ,u,v
     +          )
   
      write (6,100) u,v

      Go to 96
c---
c done
c---

  99  Continue

 100  Format (" Velocity: ",2(1x,f12.6))

      Stop
      End
