      subroutine pvm_vel 
     +
     +   (Npv
     +   ,Iflow
     +   )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c------------------------------------
c Velocity induced by a collection of 
c point vortices
c------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension x(-10:100),y(-10:100),circ(-10:100)
      Dimension u(-10:100),v(-10:100)

      common/xxyy/x,y,circ
      common/uuvv/u,v

c-----------------------------
c compute the induced velocity
c-----------------------------

      Do i=1,Npv   ! loop over point vortices

c---
c Compute velocity at point (x0,y0)
c induced by all other point vortices
c---

        x0 = x(i)
        y0 = y(i)

        u0 = 0.0
        v0 = 0.0

        Do j=1,Npv

        if(i.ne.j) then  ! skip self-induced velocity

         xx = x(j)
         yy = y(j)

         Dx  = x0-xx
         Dy  = y0-yy

c---------------------------
         if(Iflow.eq.1) then
c---------------------------

           call pv_fs
     +
     +       (x0,y0
     +       ,x(j),y(j)
     +       ,upv,vpv
     +       )

c--------------
         end if
c--------------

         u0 = u0 + circ(j)*upv
         v0 = v0 + circ(j)*vpv

         end if

       End Do

c---
c self-induced velocity is zero
c---

       u(i) = u0
       v(i) = v0

      End Do
       
c-----
c done
c-----

      return
      end
