      subroutine vp_2d_vel
     +
     +   (Iflow
     +   ,Istop
     +   )

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c--------------------------------------------
c Computes the velocity at the marker points
c around Ncntr contours
c-------------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c global variables
c---

      Dimension xg(0:200,25),yg(0:200,25)
      Dimension ug(0:200,25),vg(0:200,25)

      Dimension XCg(200,25), YCg(200,25),   Rg(200,25),   Sg(0:200,25)
      Dimension TH1g(200,25),TH2g(200,25),TH3g(200,25),orntg(200,25)

c---
c properties of patches
c---

      Dimension NSG(25),NSG1(25),NSG2(25)
      Dimension        omega(25)

c---
c common blocks for global variables
c---

      common/XXYYg/Xg,Yg
      common/ARCCg/XCg,YCg,Rg,Sg,TH1g,TH2g,TH3g,ORNTg
      common/UUVVg/Ug,Vg

c---
c various common blocks
c---

      common/ancI1/Ncntr,NSG,NSG1,NSG2
      common/ancR1/omega

      common/piii/pi,pih,piq,pi2,pi4,pi6,pi8,srpi

c----------------------------
c Contour integral evaluation
c----------------------------

      Do l = 1,Ncntr       ! run over contours

      Do j = 1,NSG(l)          ! run over points

c      write (6,200) j

       ja  =  j-1
       j1  =  j+1

        X0 =   xg(j,l)
        Y0 =   yg(j,l)
       TH0 = th2g(j,l)

       Utot = 0.0D0
       Vtot = 0.0D0

c--------------------------------------
c Non-singular integrals
c will be computed over the blended arc
c--------------------------------------

       Do 20 k=1,Ncntr     ! run over interfaces

       accx = 0.0D0
       accy = 0.0D0

       Do 21 i=1,NSG(k)      ! run over elements

       i1 = i+1

       If(l.eq.k) then
        If(j.eq.i.or.j.eq.i1)      Go to 21
        If(j.eq.1.and.i.eq.NSG(k)) Go to 21
       End If

       XC1 =   XCg(i,k)
       YC1 =   YCg(i,k)
       RD1 =    Rg(i,k)
       T11 =  TH2g(i,k)
       T21 =  TH3g(i,k)
       OR1 = ORNTg(i,k)

       XC2 =   XCg(i1,k)
       YC2 =   YCg(i1,k)
       RD2 =    Rg(i1,k)
       T12 =  TH1g(i1,k)
       T22 =  TH2g(i1,k)
       OR2 = ORNTg(i1,k)

       call arc_bl
     +
     +     (XC1,YC1,RD1,T11,T21,OR1
     +     ,XC2,YC2,RD2,T12,T22,OR2
     +     ,X0,Y0
     +     ,Iflow
     +     ,Uarc,Varc
     +     ,Istop
     +     )

c---
c      write (6,100) k,i,Uarc,Varc
c---

       accx = accx + Uarc
       accy = accy + Varc

  21  Continue

      Utot = Utot + omega(k)*accx
      Vtot = Vtot + omega(k)*accy

  20  Continue

c--------------------------------------------------
c Will integrate over the two sides of the host arc
c numbered j located at the lth interface
c-------------------------------------------------

      Ising = 1

      XCS =   XCg(j,l)
      YCS =   YCg(j,l)
      RDS =    Rg(j,l)
      T1S =  TH1g(j,l)
      T2S =  TH2g(j,l)
      T3S =  TH3g(j,l)
      ORS = ORNTg(j,l)

c---
      call arc_host
     +
     +     (XCS,YCS,RDS,T1S,T2S,ORS
     +     ,X0,Y0,TH0
     +     ,Iflow
     +     ,Uarc,Varc
     +     ,Istop
     +     )

      Utot = Utot + omega(l)*Uarc
      Vtot = Vtot + omega(l)*Varc

      call arc_host
     +
     +     (XCS,YCS,RDS,T2S,T3S,ORS
     +     ,X0,Y0,TH0
     +     ,Iflow
     +     ,Uarc,Varc
     +     ,Istop
     +     )

      Utot = Utot + omega(l)*Uarc
      Vtot = Vtot + omega(l)*Varc

c---
c     write(6,100) l,j,Uarc,Varc
c---

      Ug(j,l) = - Utot/pi4
      Vg(j,l) = - Vtot/pi4

      End Do           ! end of loop over points

      End Do           ! end of loop over contours

c-----------------------

 100  Format (1x,i3,1x,i3,10(1x,f15.10))
 200  Format (' EVALUATING THE CONTOUR INTEGRAL AT POINT:',I2)
 201  Format (' Arc:',I2)

      Return
      End

c==============================================

      subroutine arc_host
     +
     +     (XC,YC,RD,TH1,TH2,ORNT
     +     ,X0,Y0,TH0
     +     ,Iflow
     +     ,Uarc,Varc
     +     ,Istop
     +     )

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c---------------------------------------
c Computes the singular contour integral
c over a circular arc
c----------------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension ZZ(20),WW(20)

      common/ancR5/RL,wn
      common/ancI3/NGL

      common/ZZWW/ZZ,WW
      common/piii/pi,pih,piq,pi2,pi4,pi6,pi8,srpi

c---
c constants
c---

      Null = 0
      Zero = 0.0

c---
c initialize
c---

      Istop  = 0

      Uarc = 0.0
      Varc = 0.0

      tnx0 = -sin(TH0)*ORNT
      tny0 =  cos(TH0)*ORNT

c---------------------------
c Prepare for Gauss-Legendre
c---------------------------

      STH = 0.5*(TH1+TH2)
      DTH = 0.5*(TH2-TH1)

c----

      Do 1 I=1,NGL

        AN  = STH + DTH*ZZ(I)
        CS  = COS(AN)
        SN  = SIN(AN)
        XX  = XC + RD * CS
        YY  = YC + RD * SN
        tnx = -sn*ORNT
        tny =  cs*ORNT 

        If(Iflow.eq.1) then
          rkr = log((xx-x0)**2+(yy-y0)**2)
        Else If(Iflow.eq.2) then
          rkr = log( cosh(wn*(yy-y0))-cos(wn*(xx-x0)) )
        End If

        rks = log((AN-TH0)**2)      ! for desingularization

        U = rkr * tnx - rks*tnx0    ! subtract off singularity
        V = rkr * tny - rks*tny0

        Uarc = Uarc + U*WW(I)
        Varc = Varc + V*WW(I)

   1  Continue

c----

      cf = DTH*ORNT*RD

      Uarc = Uarc * cf
      Varc = Varc * cf

c---
c add back singular contribution
c---

        ARG2 = TH2-TH0
        ARG1 = TH1-TH0
        RES  = 0.0

        If(ABS(ARG2).GT.0.0000001)
     +  RES = RES + ARG2*(LOG(ABS(ARG2))-1.0)

        If(ABS(ARG1).GT.0.000001)
     +  RES = RES - ARG1*(LOG(ABS(ARG1))-1.0)

        RES  = 2.0*RD*ORNT*RES

        Uarc = Uarc + RES*tnx0
        Varc = Varc + RES*tny0

c------

 100  Format (5(1X,F10.5))

      Return
      End

c===================================================

      subroutine arc_bl
     +
     +     (XC1,YC1,RD1,T11,T21,OR1
     +     ,XC2,YC2,RD2,T12,T22,OR2
     +     ,X0,Y0
     +     ,Iflow
     +     ,Uarc,Varc
     +     ,Istop
     +     )

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c---------------------------------------
c Computes the nonsingular contour
c integral over a blended circular arc
c----------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension ZZ(20),WW(20)

      common/ancR5/RL,wn
      common/ancI3/NGL

      common/ZZWW/ZZ,WW
      common/piii/pi,pih,piq,pi2,pi4,pi6,pi8,srpi

c---
c initialize
c---

      Null = 0
      Zero = 0.0

      Istop  = 0

      Uarc = 0.0
      Varc = 0.0

c---------------------------
c Prepare for Gauss-Legendre
c---------------------------

      ST1 = 0.5*(T21+T11)
      DT1 = 0.5*(T21-T11)

      ST2 = 0.5*(T22+T12)
      DT2 = 0.5*(T22-T12)

c---
      Do 1 i=1,NGL

        AN1  = ST1 + DT1*ZZ(i)
        CS1  = COS(AN1)
        SN1  = SIN(AN1)
        XX1  = XC1 + RD1 * CS1
        YY1  = YC1 + RD1 * SN1
        tnx1 = -sn1*OR1
        tny1 =  cs1*OR1

        AN2  = ST2 + DT2*ZZ(i)
        CS2  = COS(AN2)
        SN2  = SIN(AN2)
        XX2  = XC2 + RD2 * CS2
        YY2  = YC2 + RD2 * SN2
        tnx2 = -sn2*OR2
        tny2 =  cs2*OR2

        XX = 0.5*(XX1+XX2)
        YY = 0.5*(YY1+YY2)

        tnx = 0.5*(tnx1+tnx2)
        tny = 0.5*(tny1+tny2)
        tnm = sqrt(tnx**2+tny**2)
        tnx = tnx/tnm
        tny = tny/tnm

        If(Iflow.eq.1) then
          rkr = log((xx-x0)**2+(yy-y0)**2)
        Else If(Iflow.eq.2) then
          rkr = log( cosh(wn*(yy-y0))-cos(wn*(xx-x0)) )
        End If

        U = rkr * tnx
        V = rkr * tny

        Uarc = Uarc + U*WW(i)
        Varc = Varc + V*WW(i)

  1   Continue

c---------------------------

      cf = 0.5*( DT1*OR1*RD1+ DT2*OR2*RD2 )

      Uarc = Uarc * cf
      Varc = Varc * cf

c-----
c Done
c-----

 100  Format (5(1X,F10.5))

      Return
      End
