      subroutine phase_vel (t,rlc,rll,f)

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c--------------------------------------------
c Computation of the rhs of equation (8.4.19)
c--------------------------------------------

      Implicit Double Precision (a-h,o-z)

      common/flow1/a,U0

      tmp = 37.0-rlc/3.0-5.0*rlc**2/144.0

      H = 31.5 * (3.0-rlc/12.0)/tmp       ! 1st of (8.4.21)
      S = (2.0+rlc/6.0)*tmp /315.0        ! 2nd of (8.4.21)

      U  = 2.0*U0*sin(t)
      f = (2.0*S-2.0*(2.0+H)*rll)/U

c-----
c Done
c-----

      Return
      End

c=========================================

      subroutine root (rll,rlc)

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c------------------------------------------
c Newton's method to solve (8.4.18) for rlc
c------------------------------------------
 
      Implicit Double Precision (a-h,o-z)

      parameter (eps=0.00001,tol=0.0000001)

c---
c small lamda
c---

      If(abs(rll).lt.0.000005) then
        rlc = 0.00001 
        Return
      End If

c---
c Newton's method
c---

c     write (6,*)
c     write (6,*) " Newton iterations"
c     write (6,*)

      Do i=1,50

        fnc   = f(rll,rlc)
        fnc1  = f(rll,rlc+eps)
        fncp  = (fnc1-fnc)/eps
        rlcs  = rlc
        rlc   = rlc - fnc/fncp
        error = rlc-rlcs
  
        If(abs(error).lt.tol) Go to 99

c       write (6,100) i,error

      End Do

      write (6,*) " Could not find a root of (8.4.18)"
      write (6,*) " in 50 iterations"
      Stop

c-----
c Done
c-----

  99  Continue

 100  Format(1x,i3,2(1x,f11.7))

      Return
      End

c=====================

      function f(rll,x)

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

      Implicit Double Precision (a-h,o-z)

      f = x*((37.0-x/3.0-5.0*x*x/144.0)/315.0)**2-rll

c-----
c Done
c-----

      Return
      End
