      program pohl_pol

c==========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licencing agreement
c==========================================

c--------------------------------------
c Profiles of the Pohlhausen polynomials
c--------------------------------------

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi  = 3.14159265358D0
      piq = 0.25D0*pi
      pih = 0.50D0*pi
      pi2 = 2.00D0*pi
      pi4 = 4.00D0*pi

      Null= 0

c--------
c prepare
c--------

      open (2,file="pohl_pol.out")

c---
c input
c---

 98   Continue

      write (6,*)
      write (6,*) " Please enter lamda"
      write (6,*) " 99 to quit"
      write (6,*) " ----------"
      read  (5,*) rl

      if(rl.eq.99) Go to 99

      write (6,*)
      write (6,*) " How many profile points ?"
      write (6,*) " 0 to quit"
      write (6,*) " ---------"
      read  (5,*) n

      if(n.eq.0) Go to 99

c--------
c prepare
c--------

      n1 = n+1

      xstart = 0.0 
      xend   = 1.0
      step   = (xend-xstart)/(n1-1.0)

      write (2,900) n1
c--------
c draw
c--------

      x = xstart

      Do i=1,n1
         xs = x**2
         xc = xs*x
         y = x*(2.0-2.0*xs+xc)+rl*x*(1.0-x)**3 /6.0
         write (2,900) i,y,x
         write (6,900) i,x,y
         x   = x + step
      End Do

      Go to 98

c-----
c Done
c-----

 99   Continue

      write (2,900) Null
      close (2)

 900  Format (1x,i3,4(1x,f10.5))

      Stop
      End
