clear all
close all

%================================
% inidirectinal flow in a channel
% by the BTCS method
%================================

h = 1.0;
mu = 1.0;
rho =1.0;
N=32;
dpdx=-8.0;
gx=0.0;

V1 = 0.1;
V2 = 0.5;

al = 0.40;  % alpha
al = 0.51;  % alpha
al =10.00;  % alpha

nu = mu/rho;
Dy = h/N;
Dt = al*Dy*Dy/nu;

nstep = 700;  % number of steps

%---
% grid and initial condition
%---

for i=1:N+1
 y(i) = (i-1)*Dy;
 u(i) = 0.0;
end
u(1) = V1;
u(N+1) = V2;

%---
% tridiagonal projection matrix
%---

for i=1:N-1
 atr(i) = 1.0+2*al;
 btr(i) = -al;
 ctr(i) = -al;
end

%---
% time stepping
%---

t=0.0;

%---

for step=1:nstep

 for i=1:N-1    % right-hand side
  s(i) = u(i+1)+Dt*(-dpdx/rho+gx);
 end

 t=t+Dt;
 u(1)  = V1;
 u(N+1) = V2;
 s(1)   =s(1)  + al*u(1);
 s(N-1) =s(N-1)+ al*u(N+1);

 sol = thomas (N-1,atr,btr,ctr,s);

 for i=2:N
  u(i) = sol(i-1);
 end

if(step==1)
  Handle1 = plot(u,y,'ko-');
  set(Handle1, 'erasemode', 'xor');
  set(gca,'fontsize',15)
  axis([min(V1,V2) max(V1,V2)+1.0 0 h])
  xlabel('u','fontsize',15)
  ylabel('y','fontsize',15)
else
  set(Handle1,'XData',u,'YData',y);
  pause(0.2)
  drawnow
end

end
%---
