      subroutine thomas(n,a,b,c,s,x)

c==========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licencing agreement
c==========================================

c------------------------------------------------
c        This program accompanies the book:
c
c               C. Pozrikidis
c Numerical Computation in Science and Engineering
c            Oxford University Press
c------------------------------------------------

c------------------------------------------
c Thomas algorithm for tridiagonal systems
c 
c Algorithm 3.4.1
c------------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension a(200),b(200),c(200),s(200),x(200)
      Dimension d(200),y(200)

      Parameter (tol=0.000000001)

c---
c reduction to upper bidiagonal
c---

      d(1) = b(1)/a(1)
      y(1) = s(1)/a(1)

      Do i=1,n-1
       i1 = i+1
       Den   = a(i1)-c(i1)*d(i)
       d(i1) = b(i1)/Den
       y(i1) =(s(i1)-c(i1)*y(i))/Den
      End Do
c---
c back substitution
c---

      x(N) = y(N)
      Do i=n-1,1,-1
        x(i)= y(i)-d(i)*x(i+1)
      End Do

c---
c Verification and alarm
c---

      Res = s(1)-a(1)*x(1)-b(1)*x(2)

      if(abs(Res).gt.tol) write (6,*) "thomas: alarm 1"

      Do i=2,n-1
        Res = s(i)-c(i)*x(i-1)-a(i)*x(i)-b(i)*x(i+1)
        If(abs(Res).gt.tol) write (6,*) " Alarm in Thomas"
      End Do

      Res = s(N)-c(N)*x(N-1)-a(N)*x(N)

      if(abs(Res).gt.tol) write (6,*) "thomas: alarm 2"

c---
c Done
c---

 100  Format (1x,f15.10)

      return
      end
